diff -urN ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp ./src/gb/GB.cpp
--- ../VisualBoyAdvance-1.7.2/src/gb/GB.cpp	2004-05-14 04:35:26 +0900
+++ ./src/gb/GB.cpp	2006-08-25 22:30:09 +0900
@@ -1139,6 +1591,27 @@
   if(gbCheatMap[address])
     return gbCheatRead(address);
 
+  if(address < 0x8000)
+      return gbMemoryMap[address>>12][address&0x0fff];
+
+  if(address < 0xa000)
+  {
+    // A lot of 'ugly' checks... But only way to emulate this particular behaviour...
+    if (((gbHardware & 0xa) && ((gbLcdModeDelayed !=3) || ((register_LY == 0) &&
+        (gbScreenOn==false) && (register_LCDC & 0x80)) &&
+        (gbLcdLYIncrementTicksDelayed ==(GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS)))) || 
+        ((gbHardware & 0x5) && (gbLcdModeDelayed !=3) &&
+        ((gbLcdMode !=3) ||   ((register_LY == 0) && ((gbScreenOn==false) &&
+        (register_LCDC & 0x80)) &&
+        (gbLcdLYIncrementTicks ==(GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS))))))
+      return gbMemoryMap[address>>12][address&0x0fff];
+    return 0xff;
+  }
+
+  // Used for the mirroring of 0xC000 in 0xE000
+  if ((address >= 0xe000) && (address < 0xfe00))
+    address &= ~0x2000;
+
   switch(address & 0xf000) {
   case 0x0a:
   case 0x0b:
@@ -1148,6 +1621,10 @@
   case 0x0f:
     if(address > 0xff00) {
       switch(address & 0x00ff) {
+      case 0x02:
+        return (gbMemory[0xff02]);
+      case 0x03:
+        return (0xff);
       case 0x04:
         return register_DIV;
       case 0x05:
@@ -1156,17 +1633,33 @@
         return register_TMA;
       case 0x07:
         return (0xf8 | register_TAC);
+      case 0x08:
+      case 0x09:
+      case 0x0a:
+      case 0x0b:
+      case 0x0c:
+      case 0x0d:
+      case 0x0e:
+        return (0xff);
       case 0x0f:
-        return (0xe0 | register_IF);
+        return (0xe0 | gbMemory[0xff0f]);
       case 0x40:
         return register_LCDC;
       case 0x41:
-        return (0x80 | register_STAT);
+      // This is a GB/C only bug (ie. not GBA/SP).
+      if ((gbHardware & 7) && (gbLcdMode == 2) && (gbLcdModeDelayed == 1) && (!gbSpeed))
+        return (0x80 | gbMemory[0xff41] & 0xFC);
+      else
+        return (0x80 | gbMemory[0xff41]);
       case 0x42:
         return register_SCY;
       case 0x43:
         return register_SCX;
       case 0x44:
+      if (((gbHardware & 7) && ((gbLcdMode == 1) && (gbLcdTicks == 0x71))) ||
+          (!(register_LCDC && 0x80)))
+        return 0;
+      else
         return register_LY;
       case 0x45:
         return register_LYC;
@@ -1176,6 +1669,8 @@
         return register_WY;
       case 0x4b:
         return register_WX;
+      case 0x4c:
+        return 0xff;
       case 0x4f:
         return (0xfe | register_VBK);
       case 0x51:
@@ -1188,14 +1683,55 @@
         return register_HDMA4;
       case 0x55:
         return register_HDMA5;
+      case 0x68:
+      case 0x6a:
+        if (gbCgbMode)
+          return (0x40 | gbMemory[address]);
+        else
+          return 0xc0;
+    case 0x69:
+    case 0x6b:
+      if (gbCgbMode)
+      {
+        // No access to gbPalette during mode 3 (Color Panel Demo)
+        if (((gbLcdModeDelayed != 3) && (!((gbLcdMode == 0) && (gbLcdTicks>=(GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299]-1)))) && (!gbSpeed)) ||
+           (gbSpeed && ((gbLcdMode == 1) || (gbLcdMode == 2) ||
+           ((gbLcdMode == 3) && (gbLcdTicks>(GBLCD_MODE_3_CLOCK_TICKS-2))) ||
+           ((gbLcdMode == 0) && (gbLcdTicks<=(GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299]-2))))))
+          return (gbMemory[address]);
+        else
+          return 0xff;
+      }
+      else
+        return 0xff;
       case 0x70:
-        return (0xf8 | register_SVBK);
+        if (gbCgbMode)
+          return (0xf8 | register_SVBK);
+        else
+          return 0xff;
       case 0xff:
         return register_IE;
       }
     }
+  // OAM not accessible during mode 2 & 3.
+  if(((address >= 0xfe00) && (address<0xfea0)) &&
+    ((gbLcdMode | gbLcdModeDelayed) &2))
+      return 0xff;
     break;
   }
+
+  if ((address >= 0xfea0) && (address < 0xff00))
+  {
+    if (gbHardware & 1)
+      return ((((address + ((address >> 4) - 0xfea)) >> 2) & 1) ? 0x00 : 0xff );
+    else if (gbHardware & 2)
+      return gbMemoryMap[address>>12][address & 0x0fff];
+    else if (gbHardware & 4)
+      return ((((address + ((address >> 4) - 0xfea)) >> 2) & 1) ? 0xff : 0x00 );
+    else if (gbHardware & 8)
+      return ((address & 0xf0) |((address & 0xf0)>>4));
+  }
+
   return gbMemoryMap[address>>12][address & 0x0fff];
 }
 
@@ -1203,10 +1739,28 @@
 {
   if(gbCheatMap[address])
     return gbCheatRead(address);
-  
-  if(address < 0xa000)
+
+
+  if(address < 0x8000)
     return gbMemoryMap[address>>12][address&0x0fff];
 
+  if(address < 0xa000)
+  {
+    // A lot of 'ugly' checks... But only way to emulate this particular behaviour...
+    if (((gbHardware & 0xa) && ((gbLcdModeDelayed !=3) || ((register_LY == 0) &&
+        (gbScreenOn==false) && (register_LCDC & 0x80)) &&
+        (gbLcdLYIncrementTicksDelayed ==(GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS)))) || 
+        ((gbHardware & 0x5) && (gbLcdModeDelayed !=3) &&
+        ((gbLcdMode !=3) ||   ((register_LY == 0) && ((gbScreenOn==false) &&
+        (register_LCDC & 0x80)) &&
+        (gbLcdLYIncrementTicks ==(GBLY_INCREMENT_CLOCK_TICKS-GBLCD_MODE_2_CLOCK_TICKS))))))
+      return gbMemoryMap[address>>12][address&0x0fff];
+    return 0xff;
+  }
+
+  if ((address >= 0xe000) && (address < 0xfe00))
+    address &= ~0x2000;
+
   if(address < 0xc000) {
 #ifndef FINAL_VERSION
     if(memorydebug) {
@@ -1215,11 +1769,18 @@
           PC.W);
     }
 #endif
-    
+
+  // for the 2kb ram limit (fixes crash in shawu's story
+  // but now its sram test fails, as the it expects 8kb and not 2kb...
+  // So use the 'genericflashcard' option to fix it).
+  if (address<=(0xa000+gbRamSizeMask))
+  {
     if(mapperReadRAM)
       return mapperReadRAM(address);
     return gbMemoryMap[address>>12][address & 0x0fff];
   }
+  return 0xff;
+  }
 
   if(address >= 0xff00) {
     switch(address & 0x00ff) {
@@ -1310,8 +1871,10 @@
       break;
     case 0x01:
       return gbMemory[0xff01];
+    case 0x02:
+      return (gbMemory[0xff02]);
     case 0x04:
-      return register_DIV;
+        return register_DIV;
     case 0x05:
       return register_TIMA;
     case 0x06:
@@ -1319,17 +1882,45 @@
     case 0x07:
       return (0xf8 | register_TAC);
     case 0x0f:
-      return (0xe0 | register_IF);
-    case 0x40:
+      return (0xe0 | gbMemory[0xff0f]);
+    case 0x30:
+    case 0x31:
+    case 0x32:
+    case 0x33:
+    case 0x34:
+    case 0x35:
+    case 0x36:
+    case 0x37:
+    case 0x38:
+    case 0x39:
+    case 0x3A:
+    case 0x3B:
+    case 0x3C:
+    case 0x3D:
+    case 0x3E:
+    case 0x3F:
+      if ((gbMemory[NR30] & 0x80) && (gbMemory[NR34] & 0x80))
+        return 0xFF;
+      else
+        return gbMemoryMap[address>>12][address & 0x0fff];        
+    case 0x40:        
       return register_LCDC;
     case 0x41:
-      return (0x80 | register_STAT);
+      // This is a GB/C only bug (ie. not GBA/SP).
+      if ((gbHardware & 7) && (gbLcdMode == 2) && (gbLcdModeDelayed == 1) && (!gbSpeed))
+        return (0x80 | gbMemory[0xff41] & 0xFC);
+      else
+        return (0x80 | gbMemory[0xff41]);
     case 0x42:
       return register_SCY;
     case 0x43:
       return register_SCX;
     case 0x44:
-      return register_LY;
+      if (((gbHardware & 7) && ((gbLcdMode == 1) && (gbLcdTicks == 0x71))) ||
+          (!(register_LCDC && 0x80)))
+        return (0);
+      else
+        return register_LY;
     case 0x45:
       return register_LYC;
     case 0x46:
@@ -1350,27 +1941,62 @@
       return register_HDMA4;
     case 0x55:
       return register_HDMA5;
+    case 0x68:
+    case 0x6a:
+      if (gbCgbMode)
+        return (0x40 | gbMemory[address]);
+      else
+        return 0xc0;
+    case 0x69:
+    case 0x6b:
+      if (gbCgbMode)
+      {
+        // No access to gbPalette during mode 3 (Color Panel Demo)
+        if (((gbLcdModeDelayed != 3) && (!((gbLcdMode == 0) && (gbLcdTicks>=(GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299]-1)))) && (!gbSpeed)) ||
+           (gbSpeed && ((gbLcdMode == 1) || (gbLcdMode == 2) ||
+           ((gbLcdMode == 3) && (gbLcdTicks>(GBLCD_MODE_3_CLOCK_TICKS-2))) ||
+           ((gbLcdMode == 0) && (gbLcdTicks<=(GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299]-2))))))
+          return (gbMemory[address]);
+        else
+          return 0xff;
+      }
+      else
+        return 0xff;
     case 0x70:
-      return (0xf8 | register_SVBK);
+      if (gbCgbMode)
+        return (0xf8 | register_SVBK);
+      else
+        return 0xff;
     case 0xff:
       return register_IE;
     }
   }
-  
+  // OAM not accessible during mode 2 & 3.
+  if(((address >= 0xfe00) && (address<0xfea0)) &&
+    (((gbLcdMode | gbLcdModeDelayed) &2) &&
+    (!(gbSpeed && (gbHardware & 0x2) && !(gbLcdModeDelayed & 2) && (gbLcdMode == 2))) ||
+      (gbSpeed && (gbHardware & 0x2) && (gbLcdModeDelayed == 0) && (gbLcdTicksDelayed == (GBLCD_MODE_0_CLOCK_TICKS-gbSpritesTicks[299])))))
+  return 0xff;
+
+  if ((address >= 0xfea0) && (address < 0xff00))
+  {
+    if (gbHardware & 1)
+      return ((((address + ((address >> 4) - 0xfea)) >> 2) & 1) ? 0x00 : 0xff );
+    else if (gbHardware & 2)
+      return gbMemoryMap[address>>12][address & 0x0fff];
+    else if (gbHardware & 4)
+      return ((((address + ((address >> 4) - 0xfea)) >> 2) & 1) ? 0xff : 0x00 );
+    else if (gbHardware & 8)
+      return ((address & 0xf0) |((address & 0xf0)>>4));
+  }
+
   return gbMemoryMap[address>>12][address & 0x0fff];
 }
 
 void gbVblank_interrupt()
 {
-  if(IFF & 0x80) {
-    PC.W++;
-    IFF &= 0x7f;
-  }
-  gbInterrupt &= 0xfe;
-  
-  IFF &= 0x7e;
-  register_IF &= 0xfe;
-  
+  gbCheatWrite(false); // Emulates GS codes.
+  gbMemory[0xff0f] = register_IF &= 0xfe;
   gbWriteMemory(--SP.W, PC.B.B1);
   gbWriteMemory(--SP.W, PC.B.B0);
   PC.W = 0x40;
@@ -1378,221 +2004,617 @@
 
 void gbLcd_interrupt()
 {
-  if(IFF & 0x80) {
-    PC.W++;
-    IFF &= 0x7f;
-  }    
-  gbInterrupt &= 0xfd;
-  IFF &= 0x7e;
-  register_IF &= 0xfd;
-  
+  gbMemory[0xff0f] = register_IF &= 0xfd;
   gbWriteMemory(--SP.W, PC.B.B1);
   gbWriteMemory(--SP.W, PC.B.B0);
-  
   PC.W = 0x48;
 }
 
 void gbTimer_interrupt()
 {
-  if(IFF & 0x80) {
-    PC.W++;
-    IFF &= 0x7f;
-  }
-  IFF &= 0x7e;
-  gbInterrupt &= 0xfb;
-  register_IF &= 0xfb;
-  
+  gbMemory[0xff0f] = register_IF &= 0xfb;
   gbWriteMemory(--SP.W, PC.B.B1);
   gbWriteMemory(--SP.W, PC.B.B0);
-  
   PC.W = 0x50;
 }
 
 void gbSerial_interrupt()
 {
-  if(IFF & 0x80) {
-    PC.W++;
-    IFF &= 0x7f;
-  }
-  IFF &= 0x7e;
-  gbInterrupt &= 0xf7;
-  register_IF &= 0xf7;
-  
+  gbMemory[0xff0f] = register_IF &= 0xf7;
   gbWriteMemory(--SP.W, PC.B.B1);
   gbWriteMemory(--SP.W, PC.B.B0);
-  
   PC.W = 0x58;
 }
 
 void gbJoypad_interrupt()
 {
-  if(IFF & 0x80) {
-    PC.W++;
-    IFF &= 0x7f;
-  }
-  IFF &= 0x7e;
-  gbInterrupt &= 0xef;
-  register_IF &= 0xef;
-  
+  gbMemory[0xff0f] = register_IF &= 0xef;
   gbWriteMemory(--SP.W, PC.B.B1);
   gbWriteMemory(--SP.W, PC.B.B0);
-  
   PC.W = 0x60;
 }
 
 void gbSpeedSwitch()
 {
+  gbBlackScreen = true;
   if(gbSpeed == 0) {
     gbSpeed = 1;
-    GBLCD_MODE_0_CLOCK_TICKS = 51 * 2; //127; //51 * 2;
+    GBLCD_MODE_0_CLOCK_TICKS = 51 * 2;
     GBLCD_MODE_1_CLOCK_TICKS = 1140 * 2;
-    GBLCD_MODE_2_CLOCK_TICKS = 20 * 2; //52; //20 * 2;
-    GBLCD_MODE_3_CLOCK_TICKS = 43 * 2; //99; //43 * 2;
-    GBDIV_CLOCK_TICKS = 64 * 2;
+    GBLCD_MODE_2_CLOCK_TICKS = 20 * 2;
+    GBLCD_MODE_3_CLOCK_TICKS = 43 * 2;
     GBLY_INCREMENT_CLOCK_TICKS = 114 * 2;
-    GBTIMER_MODE_0_CLOCK_TICKS = 256; //256*2;
-    GBTIMER_MODE_1_CLOCK_TICKS = 4; //4*2;
-    GBTIMER_MODE_2_CLOCK_TICKS = 16; //16*2;
-    GBTIMER_MODE_3_CLOCK_TICKS = 64; //64*2;
+    GBDIV_CLOCK_TICKS = 64;
+    GBTIMER_MODE_0_CLOCK_TICKS = 256;
+    GBTIMER_MODE_1_CLOCK_TICKS = 4;
+    GBTIMER_MODE_2_CLOCK_TICKS = 16;
+    GBTIMER_MODE_3_CLOCK_TICKS = 64;
     GBSERIAL_CLOCK_TICKS = 128 * 2;
-    gbDivTicks *= 2;
     gbLcdTicks *= 2;
+    gbLcdTicksDelayed *=2;
+    gbLcdTicksDelayed--;
     gbLcdLYIncrementTicks *= 2;
-    //    timerTicks *= 2;
-    //    timerClockTicks *= 2;
+    gbLcdLYIncrementTicksDelayed *= 2;
+    gbLcdLYIncrementTicksDelayed--;
     gbSerialTicks *= 2;
     SOUND_CLOCK_TICKS = soundQuality * 24 * 2;
     soundTicks *= 2;
-    //    synchronizeTicks *= 2;
-    //    SYNCHRONIZE_CLOCK_TICKS *= 2;
+    gbLine99Ticks = 3;
   } else {
     gbSpeed = 0;
     GBLCD_MODE_0_CLOCK_TICKS = 51;
     GBLCD_MODE_1_CLOCK_TICKS = 1140;
     GBLCD_MODE_2_CLOCK_TICKS = 20;
     GBLCD_MODE_3_CLOCK_TICKS = 43;
-    GBDIV_CLOCK_TICKS = 64;
     GBLY_INCREMENT_CLOCK_TICKS = 114;
+    GBDIV_CLOCK_TICKS = 64;
     GBTIMER_MODE_0_CLOCK_TICKS = 256;
     GBTIMER_MODE_1_CLOCK_TICKS = 4;
     GBTIMER_MODE_2_CLOCK_TICKS = 16;
     GBTIMER_MODE_3_CLOCK_TICKS = 64;
     GBSERIAL_CLOCK_TICKS = 128;
-    gbDivTicks /= 2;
-    gbLcdTicks /= 2;
-    gbLcdLYIncrementTicks /= 2;
-    //    timerTicks /= 2;
-    //    timerClockTicks /= 2;
+    gbLcdTicks >>= 1;
+    gbLcdTicksDelayed++;
+    gbLcdTicksDelayed >>=1;
+    gbLcdLYIncrementTicks >>= 1;
+    gbLcdLYIncrementTicksDelayed++;
+    gbLcdLYIncrementTicksDelayed >>= 1;
     gbSerialTicks /= 2;
     SOUND_CLOCK_TICKS = soundQuality * 24;
-    soundTicks /= 2;
-    //    synchronizeTicks /= 2;
-    //    SYNCHRONIZE_CLOCK_TICKS /= 2;    
+    soundTicks /= 2; 
+    gbLine99Ticks = 1;
+    if (gbHardware & 8)
+      gbLine99Ticks++;
   }
+  gbDmaTicks += (134)*GBLY_INCREMENT_CLOCK_TICKS + (37<<(gbSpeed ? 1 : 0));
 }
 
-void gbReset()
+bool CPUIsGBBios(const char * file)
 {
-  SP.W = 0xfffe;
-  AF.W = 0x01b0;
-  BC.W = 0x0013;
-  DE.W = 0x00d8;
-  HL.W = 0x014d;
-  PC.W = 0x0100;
-  IFF = 0;
-  gbInterrupt = 1;
-  gbInterruptWait = 0;
+  if(strlen(file) > 4) {
+    const char * p = strrchr(file,'.');
+
+    if(p != NULL) {
+      if(_stricmp(p, ".gb") == 0)
+        return true;
+      if(_stricmp(p, ".bin") == 0)
+        return true;
+      if(_stricmp(p, ".bios") == 0)
+        return true;
+    }
+  }
   
-  register_DIV = 0;
-  register_TIMA = 0;
-  register_TMA = 0;
-  register_TAC = 0;
-  register_IF = 1;
-  register_LCDC = 0x91;
-  register_STAT = 0;
-  register_SCY = 0;
-  register_SCX = 0;  
-  register_LY = 0;  
-  register_LYC = 0;
-  register_DMA = 0;
-  register_WY = 0;
-  register_WX = 0;
-  register_VBK = 0;
-  register_HDMA1 = 0;
-  register_HDMA2 = 0;
-  register_HDMA3 = 0;
-  register_HDMA4 = 0;
-  register_HDMA5 = 0;
-  register_SVBK = 0;
-  register_IE = 0;  
+  return false;
+}
 
-  if(gbCgbMode) {
-    if(gbSgbMode) {
-      if(gbEmulatorType == 5)
-        AF.W = 0xffb0;
+void gbCPUInit(const char *biosFileName, bool useBiosFile)
+{
+  useBios = false;
+  if (useBiosFile)
+  {
+    int size = 0x100;
+    if(utilLoad(biosFileName,
+                CPUIsGBBios,
+                bios,
+                size)) {
+      if(size == 0x100)
+        useBios = true;
       else
-        AF.W = 0x01b0;
-      BC.W = 0x0013;
-      DE.W = 0x00d8;
-      HL.W = 0x014d;
-      for(int i = 0; i < 8; i++)
-        gbPalette[i] = systemGbPalette[gbPaletteOption*8+i];
-    } else {
-      AF.W = 0x11b0;
-      BC.W = 0x0000;
-      DE.W = 0xff56;
-      HL.W = 0x000d;
+        systemMessage(MSG_INVALID_BIOS_FILE_SIZE, N_("Invalid BOOTROM file size"));
     }
-    if(gbEmulatorType == 4)
-      BC.B.B1 |= 0x01;
-   
-    register_HDMA5 = 0xff;
-    gbMemory[0xff68] = 0xc0;
-    gbMemory[0xff6a] = 0xc0;    
-  } else {
-    for(int i = 0; i < 8; i++)
-      gbPalette[i] = systemGbPalette[gbPaletteOption*8+i];
+  }
+}
+
+void gbGetHardwareType()
+{
+  gbCgbMode = 0;
+  gbSgbMode = 0;
+  if(gbRom[0x143] & 0x80) {
+    if((gbEmulatorType == 0) ||
+       gbEmulatorType == 1 ||
+       gbEmulatorType == 4) {
+      gbCgbMode = 1;
+    }
+  }
+
+  if((gbCgbMode == 0 ) && (gbRom[0x146] == 0x03)) {
+    if(gbEmulatorType == 0 ||
+       gbEmulatorType == 2 ||
+       gbEmulatorType == 5)
+      gbSgbMode = 1;
   }
 
+  gbHardware = 1; // GB
+  if (((gbCgbMode == 1) && (gbEmulatorType == 0)) || (gbEmulatorType == 1))
+    gbHardware = 2; // GBC
+  else if (((gbSgbMode == 1) && (gbEmulatorType == 0)) || (gbEmulatorType == 2) || (gbEmulatorType == 5))
+    gbHardware = 4; // SGB(2)
+  else if (gbEmulatorType == 4)
+    gbHardware = 8; // GBA
+
+  gbGBCColorType = 0;
+  if (gbHardware & 8) // If GBA is selected, choose the GBA default settings.
+    gbGBCColorType = 2;    // (0 = GBC, 1 = GBA, 2 = GBASP)
+}
+
+void gbReset()
+{
+  gbGetHardwareType();
+
+  oldRegister_WY = 146;
+  gbInterruptLaunched = 0;
+
+  if(gbCgbMode == 1) {
+      if (gbVram == NULL)
+        gbVram = (u8 *)malloc(0x4000);
+      if (gbWram == NULL)
+        gbWram = (u8 *)malloc(0x8000);
+      memset(gbVram,0,0x4000);
+      memset(gbPalette,0, 2*128);
+  }
+  else
+  {
+    if(gbVram != NULL) {
+      free(gbVram);
+      gbVram = NULL;
+    }
+    if(gbWram != NULL) {
+      free(gbWram);
+      gbWram = NULL;
+    }
+  }
+
+  gbLYChangeHappened = false;
+  gbLCDChangeHappened = false;
+  gbBlackScreen = false;
+  gbInterruptWait = 0;
+  gbDmaTicks = 0;
+  clockTicks = 0;
+
   if(gbSpeed) {
     gbSpeedSwitch();
     gbMemory[0xff4d] = 0;
   }
+
+  // clean Wram
+  // This kinda emulates the startup state of Wram on GB/C (not very accurate,
+  // but way closer to the reality than filling it with 00es or FFes).
+  // On GBA/GBASP, it's kinda filled with random data.
+  // In all cases, most of the 2nd bank is filled with 00s.
+  // The starting data are important for some 'buggy' games, like Buster Brothers or
+  // Karamuchou ha Oosawagi!.
+  if (gbMemory != NULL)
+  {
+    memset(gbMemory,0xff, 65536);
+    for (int temp = 0xC000; temp < 0xE000; temp++)
+      if ((temp & 0x8) ^((temp & 0x800)>>8))
+      {
+          if ((gbHardware & 0x02) && (gbGBCColorType == 0))
+            gbMemory[temp] = 0x0;
+          else
+            gbMemory[temp] = 0x0f;
+      }
+
+      else
+          gbMemory[temp] = 0xff;
+  }
+
+
+      
+  // clean LineBuffer
+  if (gbLineBuffer != NULL)
+    memset(gbLineBuffer, 0, sizeof(gbLineBuffer));
+  // clean Pix
+  if (pix != NULL)
+    memset(pix, 0, sizeof(pix));
+  // clean Vram
+  if (gbVram != NULL)
+    memset(gbVram, 0, 0x4000);
+  // clean Wram 2
+  // This kinda emulates the startup state of Wram on GBC (not very accurate,
+  // but way closer to the reality than filling it with 00es or FFes).
+  // On GBA/GBASP, it's kinda filled with random data.
+  // In all cases, most of the 2nd bank is filled with 00s.
+  // The starting data are important for some 'buggy' games, like Buster Brothers or
+  // Karamuchou ha Oosawagi!
+  if (gbWram != NULL)
+  {
+      for (int i = 0; i<8; i++)
+          if (i != 2)
+      memcpy ((u16 *)(gbWram+i*0x1000), (u16 *)(gbMemory+0xC000), 0x1000);
+  }
+
+  memset(gbSCYLine,0,sizeof(gbSCYLine));
+  memset(gbSCXLine,0,sizeof(gbSCXLine));
+  memset(gbBgpLine,0xfc,sizeof(gbBgpLine));
+  if (gbHardware & 5)
+  {
+    memset(gbObp0Line,0xff,sizeof(gbObp0Line));
+    memset(gbObp1Line,0xff,sizeof(gbObp1Line));
+  }
+  else
+  {
+    memset(gbObp0Line,0x0,sizeof(gbObp0Line));
+    memset(gbObp1Line,0x0,sizeof(gbObp1Line));
+  }
+  memset(gbSpritesTicks,0x0,sizeof(gbSpritesTicks));
+
+  SP.W = 0xfffe;
+  AF.W = 0x01b0;
+  BC.W = 0x0013;
+  DE.W = 0x00d8;
+  HL.W = 0x014d;
+  PC.W = 0x0100;
+  IFF = 0;
+  gbInt48Signal = 0;
   
-  gbDivTicks = GBDIV_CLOCK_TICKS;
-  gbLcdMode = 2;
-  gbLcdTicks = GBLCD_MODE_2_CLOCK_TICKS;
-  gbLcdLYIncrementTicks = 0;
-  gbTimerTicks = 0;
-  gbTimerClockTicks = 0;
+  register_TIMA = 0;
+  register_TMA = 0;
+  register_TAC = 0;
+  gbMemory[0xff0f] = register_IF = 1;
+  gbMemory[0xff40] = register_LCDC = 0x91;
+  gbMemory[0xff47] = 0xfc;
+
+  if (gbCgbMode)
+    gbMemory[0xff4d] = 0x7e;
+  else
+    gbMemory[0xff4d] = 0xff;
+
+  if (!gbCgbMode)
+    gbMemory[0xff70] = gbMemory[0xff74] = 0xff;
+
+  if (gbCgbMode)
+    gbMemory[0xff56] = 0x3e;
+  else
+    gbMemory[0xff56] = 0xff;
+
+  register_SCY = 0;
+  register_SCX = 0;   
+  register_LYC = 0;
+  register_DMA = 0xff;
+  register_WY = 0;
+  register_WX = 0;
+  register_VBK = 0;
+  register_HDMA1 = 0xff;
+  register_HDMA2 = 0xff;
+  register_HDMA3 = 0xff;
+  register_HDMA4 = 0xff;
+  register_HDMA5 = 0xff;
+  register_SVBK = 0;
+  register_IE = 0;  
+
+  if (gbCgbMode)
+    gbMemory[0xff02] = 0x7c;
+  else
+    gbMemory[0xff02] = 0x7e;
+
+  gbMemory[0xff03] = 0xff;
+  int i;
+  for (i = 0x8; i<0xf; i++)
+    gbMemory[0xff00+i] = 0xff;
+
+  gbMemory[0xff13] = 0xff;
+  gbMemory[0xff15] = 0xff;
+  gbMemory[0xff18] = 0xff;
+  gbMemory[0xff1d] = 0xff;
+  gbMemory[0xff1f] = 0xff;
+
+  for (i = 0x27; i<0x30; i++)
+    gbMemory[0xff00+i] = 0xff;
+
+  gbMemory[0xff4c] = 0xff;
+  gbMemory[0xff4e] = 0xff;
+  gbMemory[0xff50] = 0xff;
+
+  for (i = 0x57; i<0x68; i++)
+    gbMemory[0xff00+i] = 0xff;
+
+  for (i = 0x5d; i<0x70; i++)
+    gbMemory[0xff00+i] = 0xff;
+
+  gbMemory[0xff71] = 0xff;
+
+  for (i = 0x78; i<0x80; i++)
+    gbMemory[0xff00+i] = 0xff;
+
+  if (gbHardware & 0xa)
+  {
+
+      if (gbHardware & 2)
+      {
+        AF.W = 0x1180;
+        BC.W = 0x0000;
+      }
+      else
+      {
+        AF.W = 0x1100;
+        BC.W = 0x0100; // GBA/SP have B = 0x01 (which means GBC & GBA/SP bootrom are different !)
+      }
+
+    gbMemory[0xff26] = 0xf1;
+    if (gbCgbMode)
+    {
+
+      gbMemory[0xff31] = 0xff;
+      gbMemory[0xff33] = 0xff;
+      gbMemory[0xff35] = 0xff;
+      gbMemory[0xff37] = 0xff;
+      gbMemory[0xff39] = 0xff;
+      gbMemory[0xff3b] = 0xff;
+      gbMemory[0xff3d] = 0xff;
+
+      gbMemory[0xff44] = register_LY = 0x90;
+      gbDivTicks = 0x19 + ((gbHardware & 2) >> 1);
+      gbInternalTimer = 0x58 + ((gbHardware & 2) >> 1);
+      gbLcdTicks = GBLCD_MODE_1_CLOCK_TICKS -
+                   (register_LY-0x8F)*GBLY_INCREMENT_CLOCK_TICKS + 72 + ((gbHardware & 2) >> 1);
+      gbLcdLYIncrementTicks = 72 + ((gbHardware & 2) >> 1);
+      gbMemory[0xff04] = register_DIV = 0x1E;
+    }
+    else
+    {
+      gbMemory[0xff44] = register_LY = 0x94;
+      gbDivTicks = 0x22 + ((gbHardware & 2) >> 1);
+      gbInternalTimer = 0x61 + ((gbHardware & 2) >> 1);
+      gbLcdTicks = GBLCD_MODE_1_CLOCK_TICKS -
+                   (register_LY-0x8F)*GBLY_INCREMENT_CLOCK_TICKS + 25 + ((gbHardware & 2) >> 1);
+      gbLcdLYIncrementTicks = 25 + ((gbHardware & 2) >> 1);
+      gbMemory[0xff04] = register_DIV = 0x26;
+    }
+
+
+    DE.W = 0xff56;
+    HL.W = 0x000d;
+   
+    register_HDMA5 = 0xff;
+    gbMemory[0xff68] = 0xc0;
+    gbMemory[0xff6a] = 0xc0;
+
+    
+    gbMemory[0xff41] = register_STAT = 0x81;
+    gbLcdMode = 1;
+  }
+  else
+  {
+    if (gbHardware & 4)
+    {
+      if(gbEmulatorType == 5)
+        AF.W = 0xffb0;
+      else
+        AF.W = 0x01b0;
+      BC.W = 0x0013;
+      DE.W = 0x00d8;
+      HL.W = 0x014d;
+    }
+    gbDivTicks = 14;
+    gbInternalTimer = gbDivTicks--;
+    gbMemory[0xff04] = register_DIV = 0xAB;
+    gbMemory[0xff41] = register_STAT = 0x85;
+    gbMemory[0xff44] = register_LY = 0x00; 
+    gbLcdTicks = 15;
+    gbLcdLYIncrementTicks = 114+gbLcdTicks;
+    gbLcdMode = 1;
+
+    // used for the handling of the gb Boot Rom
+    if ((gbHardware & 5) && (bios != NULL) && useBios && !skipBios)
+    {
+      memcpy ((u8 *)(gbMemory), (u8 *)(gbRom), 0x1000);
+      memcpy ((u8 *)(gbMemory), (u8 *)(bios), 0x100);
+      gbWhiteScreen = 0;
+
+      gbInternalTimer = 0x3e;
+      gbDivTicks = 0x3f;
+      gbMemory[0xff04] = register_DIV = 0x00;
+      PC.W = 0x0000;
+      register_LCDC = 0x11;
+      gbScreenOn = false;
+      gbLcdTicks = 0;
+      gbLcdMode = 0;
+      gbLcdModeDelayed = 0;
+      gbMemory[0xff41] = register_STAT &= 0xfc;
+      gbInt48Signal = 0;
+      gbLcdLYIncrementTicks = GBLY_INCREMENT_CLOCK_TICKS;
+    }
+  }
+
+  gbLine99Ticks = 1;
+  if (gbHardware & 8)
+    gbLine99Ticks++;
+
+  gbLcdModeDelayed = gbLcdMode;
+  gbLcdTicksDelayed = gbLcdTicks+1;
+  gbLcdLYIncrementTicksDelayed = gbLcdLYIncrementTicks+1;
+
+
+  gbTimerModeChange = false;
+  gbTimerOnChange = false;
+  gbTimerOn = false;
+
+  if(gbCgbMode) {
+    for (int i = 0; i<0x20; i++)
+      gbPalette[i] = 0x7fff;
+
+    // This is just to show that the starting values of the OBJ palettes are different
+    // between the 3 consoles, and that they 'kinda' stay the same at each reset
+    // (they can slightly change, somehow (randomly?)).
+    // You can check the effects of gbGBCColorType on the "Vila Caldan Color" gbc demo.
+    // Note that you could also check the Div register to check on which system the game
+    // is running (GB,GBC and GBA(SP) have different startup values).
+    // Unfortunatly, I don't have any SGB system, so I can't get their starting values.
+
+    if (gbGBCColorType == 0) // GBC Hardware
+    {
+    gbPalette[0x20] = 0x0600;
+    gbPalette[0x21] = 0xfdf3;
+    gbPalette[0x22] = 0x041c;
+    gbPalette[0x23] = 0xf5db; 
+    gbPalette[0x24] = 0x4419;
+    gbPalette[0x25] = 0x57ea;
+    gbPalette[0x26] = 0x2808;
+    gbPalette[0x27] = 0x9b75;
+    gbPalette[0x28] = 0x129b;
+    gbPalette[0x29] = 0xfce0;
+    gbPalette[0x2a] = 0x22da;
+    gbPalette[0x2b] = 0x4ac5;
+    gbPalette[0x2c] = 0x2d71;
+    gbPalette[0x2d] = 0xf0c2;
+    gbPalette[0x2e] = 0x5137;
+    gbPalette[0x2f] = 0x2d41;
+    gbPalette[0x30] = 0x6b2d;
+    gbPalette[0x31] = 0x2215;
+    gbPalette[0x32] = 0xbe0a;
+    gbPalette[0x33] = 0xc053;
+    gbPalette[0x34] = 0xfe5f;
+    gbPalette[0x35] = 0xe000;
+    gbPalette[0x36] = 0xbe10;
+    gbPalette[0x37] = 0x914d;
+    gbPalette[0x38] = 0x7f91;
+    gbPalette[0x39] = 0x02b5;
+    gbPalette[0x3a] = 0x77ac;
+    gbPalette[0x3b] = 0x14e5;
+    gbPalette[0x3c] = 0xcf89;
+    gbPalette[0x3d] = 0xa03d;
+    gbPalette[0x3e] = 0xfd50;
+    gbPalette[0x3f] = 0x91ff;
+    }
+    else if (gbGBCColorType == 1) // GBA Hardware
+    {
+    gbPalette[0x20] = 0xbe00;
+    gbPalette[0x21] = 0xfdfd;
+    gbPalette[0x22] = 0xbd69;
+    gbPalette[0x23] = 0x7baf;
+    gbPalette[0x24] = 0xf5ff;
+    gbPalette[0x25] = 0x3f8f;
+    gbPalette[0x26] = 0xcee5;
+    gbPalette[0x27] = 0x5bf7;
+    gbPalette[0x28] = 0xb35b;
+    gbPalette[0x29] = 0xef97;
+    gbPalette[0x2a] = 0xef9f;
+    gbPalette[0x2b] = 0x97f7;
+    gbPalette[0x2c] = 0x82bf;
+    gbPalette[0x2d] = 0x9f3d;
+    gbPalette[0x2e] = 0xddde;
+    gbPalette[0x2f] = 0xbad5;
+    gbPalette[0x30] = 0x3cba;
+    gbPalette[0x31] = 0xdfd7;
+    gbPalette[0x32] = 0xedea;
+    gbPalette[0x33] = 0xfeda;
+    gbPalette[0x34] = 0xf7f9;
+    gbPalette[0x35] = 0xfdee;
+    gbPalette[0x36] = 0x6d2f;
+    gbPalette[0x37] = 0xf0e6;
+    gbPalette[0x38] = 0xf7f0;
+    gbPalette[0x39] = 0xf296;
+    gbPalette[0x3a] = 0x3bf1;
+    gbPalette[0x3b] = 0xe211;
+    gbPalette[0x3c] = 0x69ba;
+    gbPalette[0x3d] = 0x3d0d;
+    gbPalette[0x3e] = 0xdfd3;
+    gbPalette[0x3f] = 0xa6ba;
+    }
+    else if (gbGBCColorType == 2) // GBASP Hardware
+    {
+    gbPalette[0x20] = 0x9c00;
+    gbPalette[0x21] = 0x6340;
+    gbPalette[0x22] = 0x10c6;
+    gbPalette[0x23] = 0xdb97;
+    gbPalette[0x24] = 0x7622;
+    gbPalette[0x25] = 0x3e57;
+    gbPalette[0x26] = 0x2e12;
+    gbPalette[0x27] = 0x95c3;
+    gbPalette[0x28] = 0x1095;
+    gbPalette[0x29] = 0x488c;
+    gbPalette[0x2a] = 0x8241;
+    gbPalette[0x2b] = 0xde8c;
+    gbPalette[0x2c] = 0xfabc;
+    gbPalette[0x2d] = 0x0e81;
+    gbPalette[0x2e] = 0x7675;
+    gbPalette[0x2f] = 0xfdec;
+    gbPalette[0x30] = 0xddfd;
+    gbPalette[0x31] = 0x5995;
+    gbPalette[0x32] = 0x066a;
+    gbPalette[0x33] = 0xed1e;
+    gbPalette[0x34] = 0x1e84;
+    gbPalette[0x35] = 0x1d14;
+    gbPalette[0x36] = 0x11c3;
+    gbPalette[0x37] = 0x2749;
+    gbPalette[0x38] = 0xa727;
+    gbPalette[0x39] = 0x6266;
+    gbPalette[0x3a] = 0xe27b;
+    gbPalette[0x3b] = 0xe3fc;
+    gbPalette[0x3c] = 0x1f76;
+    gbPalette[0x3d] = 0xf158;
+    gbPalette[0x3e] = 0x468e;
+    gbPalette[0x3f] = 0xa540;
+    }
+  } else {
+    if(gbSgbMode) {
+      for(int i = 0; i < 8; i++)
+        gbPalette[i] = systemGbPalette[gbPaletteOption*8+i];
+
+    }
+    for(int i = 0; i < 8; i++)
+      gbPalette[i] = systemGbPalette[gbPaletteOption*8+i];
+  }
+
+  GBTIMER_MODE_0_CLOCK_TICKS = 256;
+  GBTIMER_MODE_1_CLOCK_TICKS = 4;
+  GBTIMER_MODE_2_CLOCK_TICKS = 16;
+  GBTIMER_MODE_3_CLOCK_TICKS = 64;
+  
+  GBLY_INCREMENT_CLOCK_TICKS = 114;
+  gbTimerTicks = GBTIMER_MODE_0_CLOCK_TICKS;
+  gbTimerClockTicks = GBTIMER_MODE_0_CLOCK_TICKS;
   gbSerialTicks = 0;
   gbSerialBits = 0;
   gbSerialOn = 0;
   gbWindowLine = -1;
-  gbTimerOn = 0;
+  gbTimerOn = false;
   gbTimerMode = 0;
-  //  gbSynchronizeTicks = GBSYNCHRONIZE_CLOCK_TICKS;
   gbSpeed = 0;
   gbJoymask[0] = gbJoymask[1] = gbJoymask[2] = gbJoymask[3] = 0;
   
   if(gbCgbMode) {
     gbSpeed = 0;
     gbHdmaOn = 0;
-    gbHdmaSource = 0x0000;
-    gbHdmaDestination = 0x8000;
+    gbHdmaSource = 0x99d0;
+    gbHdmaDestination = 0x99d0;
     gbVramBank = 0;
     gbWramBank = 1;
-    register_LY = 0x90;
-    gbLcdMode = 1;
-    for(int i = 0; i < 64; i++)
-      gbPalette[i] = 0x7fff;
+
   }
 
-  if(gbSgbMode) {
+  // used to clean the borders
+  if (gbSgbMode)
+  {
+    gbSgbResetFlag = true;
     gbSgbReset();
+    if (gbBorderOn)
+      gbSgbRenderBorder();
+    gbSgbResetFlag = false;
   }
 
-  for(int i =0; i < 4; i++)
+  for(i = 0; i < 4; i++)
     gbBgp[i] = gbObp0[i] = gbObp1[i] = i;
 
   memset(&gbDataMBC1,0, sizeof(gbDataMBC1));
@@ -1613,7 +2635,23 @@
   memset(&gbDataHuC3, 0, sizeof(gbDataHuC3));
   gbDataHuC3.mapperROMBank = 1;
 
-  gbMemoryMap[0x00] = &gbRom[0x0000];
+  memset(&gbDataTAMA5,0, 26*sizeof(int));
+  gbDataTAMA5.mapperROMBank = 1;
+
+  memset(&gbDataMMM01,0, sizeof(gbDataMMM01));
+  gbDataMMM01.mapperROMBank = 1;
+
+  if (useBios && !skipBios && (gbHardware & 5))
+  {
+    gbMemoryMap[0x00] = &gbMemory[0x0000];
+    inBios = true;
+  }
+  else
+  {
+    gbMemoryMap[0x00] = &gbRom[0x0000];
+    inBios = false;
+  }
+
   gbMemoryMap[0x01] = &gbRom[0x1000];
   gbMemoryMap[0x02] = &gbRom[0x2000];
   gbMemoryMap[0x03] = &gbRom[0x3000];
@@ -1638,7 +2676,7 @@
     gbMemoryMap[0x0c] = &gbMemory[0xc000];
     gbMemoryMap[0x0d] = &gbMemory[0xd000];
     gbMemoryMap[0x0e] = &gbMemory[0xe000];
-    gbMemoryMap[0x0f] = &gbMemory[0xf000];    
+    gbMemoryMap[0x0f] = &gbMemory[0xf000]; 
   }
 
   if(gbRam) {
